# BlueSky Software Installer

BlueSky is intended to become a suite of tools including an OS Setup Routine based on WIM technology, a Package Manager conceptually based on the original XPInstall, and a Setup and Repair LiveCD Environment based on whatever the primary BinOC/Linux project is.

## The LiveCD

For now think Windows Preinstallation Environment if it was actually useful like a LiveCD or any installer LiveCD if it was focused on Installing and Recovery.

OS Installation using Windows Imaging Technology (WIM)

## The OS Installer

WIM has existed since before the Windows Longhorn Omega-13 code reset that resulted in what was released as Windows Vista. One of the few technologies to persist. BinOC has been making extensive use of the technology since Longhorn build 4008. With the wimlib open source implimentation and support for `--unix-data` the same technology can be used to create, edit, and read WIM files for the same purposes as Microsoft uses it on and for Linux and other unix-like operating systems.

As a single-instance file-based indexed imaging technology the total size of any WIM file will be a single instance of any unique copy of a file, compressed. This is how Microsoft can ship dozens of different Windows SKUs on the same media. Way cooler than composing each iso and then storing and serving mostly duplicate data.

This installer will have to do the following things to install a Linux system, minimum:

- Probe Hardware
- Parition the Hard Drive
- Apply `install.wim`
- Install Grub
- Install Kernel and generate initramfs OR Compile a Kernel with stuff built in on the fly for initrd-free installs.
- Perform post-setup tasks

## The Software Package Manager

XPInstall was much more than Firfox Add-ons once upon a time and has similarities to other package systems. A conceptually XPInstall based package manager would be kinda cool espcially since it would be very re-pack friendly and trivial to create. If it presented a uniform GUI experience on top of cli would be amazing.

- zip-based container (`.xpsky` files)
- metadata and install scripts
- contains tarball of actual content to be extracted
- central database
- package repositories
- Support xz-compressed tarballs or wim file (package.txz/package.wim) for package contents.
